=== modified file '.bzrignore'
--- .bzrignore	2015-09-14 14:10:37 +0000
+++ .bzrignore	2015-11-30 15:39:52 +0000
@@ -20,6 +20,6 @@
 tests/unit/tst_i18n/tst_*/*/share/locale/en/LC_MESSAGES/*.mo
 tests/unit/tst_i18n/*/share/locale/en/LC_MESSAGES/*.mo
 tests/unit/tst_units/dpr*/dpr*
-tests/apicheck/apicheck
+apicheck/apicheck
 ubuntu-ui-toolkit-launcher/ubuntu-ui-toolkit-launcher
 build_paths.inc

=== renamed directory 'tests/apicheck' => 'apicheck'
=== modified file 'apicheck/apicheck.pro'
--- tests/apicheck/apicheck.pro	2015-07-24 08:02:46 +0000
+++ apicheck/apicheck.pro	2015-11-30 15:39:52 +0000
@@ -8,6 +8,3 @@
 apicheck.path = $$installPath
 apicheck.files = apicheck
 INSTALLS += apicheck
-
-check.commands += $${ROOT_SOURCE_DIR}/tests/qmlapicheck.sh || exit 1;
-check.commands += $${ROOT_SOURCE_DIR}/tests/apicheck/test/test.sh || exit 1;

=== renamed directory 'tests/apicheck/test' => 'tests/api'
=== added file 'tests/api/Extinct/Animals/Andrewsarchus.qml'
--- tests/api/Extinct/Animals/Andrewsarchus.qml	1970-01-01 00:00:00 +0000
+++ tests/api/Extinct/Animals/Andrewsarchus.qml	2015-11-30 15:39:52 +0000
@@ -0,0 +1,25 @@
+/*
+ * Copyright (C) 2015 Canonical, Ltd.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 3.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+import QtQuick 2.0
+
+Item {
+    id: body
+    /*!
+       \qmlproperty int skullSize
+    */
+    property int skullSize
+}

=== added file 'tests/api/Extinct/Animals/AnimalModule.pro'
--- tests/api/Extinct/Animals/AnimalModule.pro	1970-01-01 00:00:00 +0000
+++ tests/api/Extinct/Animals/AnimalModule.pro	2015-11-30 15:39:52 +0000
@@ -0,0 +1,16 @@
+CXX_MODULE = qml
+TARGET = ExtinctAnimals
+TARGETPATH = Extinct/Animals
+IMPORT_VERSION = 0.1
+
+include(plugin/plugin.pri)
+
+QML_FILES += \
+    Andrewsarchus.qml \
+    Paratriisodon.qml \
+    gigantophis.qml \
+    test.qml \
+    digger.js \
+
+load(ubuntu_qml_plugin)
+

=== added file 'tests/api/Extinct/Animals/Animals.pro'
--- tests/api/Extinct/Animals/Animals.pro	1970-01-01 00:00:00 +0000
+++ tests/api/Extinct/Animals/Animals.pro	2015-11-30 15:39:52 +0000
@@ -0,0 +1,3 @@
+TEMPLATE = subdirs
+
+SUBDIRS += AnimalModule.pro

=== added file 'tests/api/Extinct/Animals/Paratriisodon.qml'
--- tests/api/Extinct/Animals/Paratriisodon.qml	1970-01-01 00:00:00 +0000
+++ tests/api/Extinct/Animals/Paratriisodon.qml	2015-11-30 15:39:52 +0000
@@ -0,0 +1,30 @@
+/*
+ * Copyright (C) 2015 Canonical, Ltd.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 3.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+import QtQuick 2.0
+
+Item {
+    id: body
+    /*!
+       \qmlproperty int skullSize
+    */
+    property int skullSize
+
+    /*!
+       \qmlproperty real saggitalCrestSize
+    */
+    property real saggitalCrestSize
+}

=== added directory 'tests/api/Extinct/Animals/plugin'
=== added file 'tests/api/Extinct/Animals/plugin/plugin.cpp'
--- tests/api/Extinct/Animals/plugin/plugin.cpp	1970-01-01 00:00:00 +0000
+++ tests/api/Extinct/Animals/plugin/plugin.cpp	2015-11-30 15:39:52 +0000
@@ -0,0 +1,30 @@
+/*
+ * Copyright 2014 Canonical Ltd.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser General Public License as published by
+ * the Free Software Foundation; version 3.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include "plugin.h"
+#include "smilodon.h"
+
+#include <QQuickItem>
+#include <QtQml>
+
+void ExtinctAnimalsPlugin::registerTypes(const char *uri)
+{
+    Q_ASSERT(uri == QLatin1String("Extinct.Animals"));
+    qmlRegisterType<UCArgument>(uri, 1, 0, "Smilodon");
+    qmlRegisterType<UCArgument>(uri, 0, 1, "ScimitarCat");
+    qmlRegisterType(QUrl(baseUrl().toString() + "/Andrewsarchus.qml"), uri, 0, 1, "Andrewsarchus");
+    qmlRegisterType(QUrl(baseUrl().toString() + "/Paratriisodon.qml"), uri, 2, 0, "Andrewsarchus");
+}

=== added file 'tests/api/Extinct/Animals/plugin/plugin.h'
--- tests/api/Extinct/Animals/plugin/plugin.h	1970-01-01 00:00:00 +0000
+++ tests/api/Extinct/Animals/plugin/plugin.h	2015-11-30 15:39:52 +0000
@@ -0,0 +1,31 @@
+/*
+ * Copyright 2014 Canonical Ltd.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser General Public License as published by
+ * the Free Software Foundation; version 3.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef EXTINCT_ANIMALS_PLUGIN_H
+#define EXTINCT_ANIMALS_PLUGIN_H
+
+#include <QtQml/QQmlExtensionPlugin>
+
+class ExtinctAnimalsPlugin : public QQmlExtensionPlugin
+{
+    Q_OBJECT
+    Q_PLUGIN_METADATA(IID "org.qt-project.Qt.QQmlExtensionInterface")
+
+public:
+    void registerTypes(const char *uri);
+};
+
+#endif // EXTINCT_ANIMALS_PLUGIN_H

=== added file 'tests/api/Extinct/Animals/plugin/plugin.pri'
--- tests/api/Extinct/Animals/plugin/plugin.pri	1970-01-01 00:00:00 +0000
+++ tests/api/Extinct/Animals/plugin/plugin.pri	2015-11-30 15:39:52 +0000
@@ -0,0 +1,20 @@
+QT *= core-private qml qml-private quick quick-private gui-private testlib
+
+equals(QT_MAJOR_VERSION, 5):lessThan(QT_MINOR_VERSION, 2) {
+    QT *= v8-private
+}
+
+CONFIG  += no_keywords
+DEFINES += UBUNTU_QML_IMPORT_PATH='\\"$${ROOT_BUILD_DIR}/qml\\"'
+DEFINES += QT_USE_QSTRINGBUILDER
+
+TARGET = $$qtLibraryTarget($$TARGET)
+uri = Extinct.Animals
+
+HEADERS += \
+    $$PWD/plugin.h \
+    $$PWD/smilodon.h \
+
+SOURCES += \
+    $$PWD/plugin.cpp \
+    $$PWD/smilodon.cpp \

=== added file 'tests/api/Extinct/Animals/plugin/smilodon.cpp'
--- tests/api/Extinct/Animals/plugin/smilodon.cpp	1970-01-01 00:00:00 +0000
+++ tests/api/Extinct/Animals/plugin/smilodon.cpp	2015-11-30 15:39:52 +0000
@@ -0,0 +1,87 @@
+/*
+ * Copyright 2015 Canonical Ltd.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser General Public License as published by
+ * the Free Software Foundation; version 3.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ * Author: Christian Dywan <christian.dywan@canonical.com>
+ */
+
+#include "smilodon.h"
+
+/*!
+ * \qmltype Argument
+ * \instantiates UCArgument
+ * \inqmlmodule Ubuntu.Components 1.1
+ * \ingroup ubuntu-commandline
+ * \brief The Argument class specifies what type a given command line parameter should be.
+ *
+ * \b Important: Argument is not used on its own but must be a child of \l Arguments.
+ *
+ * An Argument is defined by its \l name and \l valueNames properties which correspond
+ * to a command line parameter (e.g. \e{--target}) and the values passed to it
+ * (e.g. \e{--target=http://myaddress}).
+ *
+ * For example, the following code allows to retrieve parameters on the
+ * command line of the form \e{--target=URL}:
+ *
+ * \qml
+ * Argument {
+ *     name: "target"
+ *     help: "address of the resource to retrieve"
+ *     required: true
+ *     valueNames: ["URL"]
+ * }
+ * \endqml
+ *
+ * To retrieve a value passed to the parameter knowing its position, use the \l at
+ * method.
+ *
+ * \sa Arguments
+ *
+ */
+
+UCArgument::UCArgument(QObject *parent) :
+    QObject(parent)
+{
+}
+
+/*!
+ * \qmlproperty string Argument::name
+ *
+ * Name identifying the command line argument.
+ *
+ * For example 'target' corrsesponds to the \e{'--target'} command line argument.
+ *
+ */
+QString UCArgument::name() const
+{
+    return m_name;
+}
+
+void UCArgument::setName(const QString &name)
+{
+    m_name = name;
+    Q_EMIT(nameChanged());
+}
+
+/*!
+ * \qmlmethod string Argument::at(int i)
+ *
+ * Returns the \e{i}th value of the argument.
+ * Values are counted from 0.
+ *
+ */
+QString UCArgument::paw(int i) const
+{
+    return QString("Paw #%1").arg(i);
+}

=== added file 'tests/api/Extinct/Animals/plugin/smilodon.h'
--- tests/api/Extinct/Animals/plugin/smilodon.h	1970-01-01 00:00:00 +0000
+++ tests/api/Extinct/Animals/plugin/smilodon.h	2015-11-30 15:39:52 +0000
@@ -0,0 +1,47 @@
+/*
+ * Copyright 2015 Canonical Ltd.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser General Public License as published by
+ * the Free Software Foundation; version 3.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ * Author: Christian Dywan <christian.dywan@canonical.com>
+ */
+
+#ifndef UCARGUMENT_H
+#define UCARGUMENT_H
+
+#include <QtCore/QObject>
+#include <QtCore/QStringList>
+#include <QtCore/QVariant>
+
+class UCArgument : public QObject
+{
+    Q_OBJECT
+
+    Q_PROPERTY(QString name READ name WRITE setName NOTIFY nameChanged)
+
+public:
+    explicit UCArgument(QObject *parent = 0);
+
+    QString name() const;
+    void setName(const QString &name);
+
+    Q_INVOKABLE QString paw(int i) const;
+
+Q_SIGNALS:
+    void nameChanged();
+
+private:
+    QString m_name;
+};
+
+#endif // UCARGUMENT_H

=== modified file 'tests/api/Extinct/Animals/qmldir'
--- tests/apicheck/test/Extinct/Animals/qmldir	2015-07-14 14:01:10 +0000
+++ tests/api/Extinct/Animals/qmldir	2015-11-30 15:39:52 +0000
@@ -1,4 +1,5 @@
 module Extinct.Animals
+plugin ExtinctAnimals
 Titanoboa 4.2 test.qml
 Gigantophis 4.3 gigantophis.qml
 internal WoollyMammoth mammoth.qml

=== added file 'tests/api/Extinct/Extinct.pro'
--- tests/api/Extinct/Extinct.pro	1970-01-01 00:00:00 +0000
+++ tests/api/Extinct/Extinct.pro	2015-11-30 15:39:52 +0000
@@ -0,0 +1,3 @@
+TEMPLATE = subdirs
+
+SUBDIRS = Animals

=== added file 'tests/api/api.pro'
--- tests/api/api.pro	1970-01-01 00:00:00 +0000
+++ tests/api/api.pro	2015-11-30 15:39:52 +0000
@@ -0,0 +1,7 @@
+TEMPLATE = subdirs
+
+SUBDIRS = Extinct
+
+OTHER_FILES += test.sh
+
+check.commands += ./test.sh || exit 1;

=== modified file 'tests/api/components.api'
--- tests/apicheck/test/components.api	2015-11-04 14:58:18 +0000
+++ tests/api/components.api	2015-11-30 15:39:52 +0000
@@ -1,8 +1,14 @@
+Extinct.Animals.Andrewsarchus 2.0: Item
+    property double saggitalCrestSize
+    property int skullSize
 Extinct.Animals.Excavator 1.0
 Extinct.Animals.Gigantophis 4.3: QQuickItem
     property bool extinct
     function var first()
     function var fourth()
+Extinct.Animals.Smilodon 1.0 ScimitarCat 0.1: QtObject
+    function string paw(int i)
+    property string name
 Extinct.Animals.Titanoboa 4.2 MonsterSnake 3.1: Item
     property string bar
     property var basket

=== modified file 'tests/api/test.sh'
--- tests/apicheck/test/test.sh	2015-07-14 14:39:57 +0000
+++ tests/api/test.sh	2015-11-30 15:39:52 +0000
@@ -16,16 +16,19 @@
 #
 ################################################################################
 
-. `dirname $0`/../../../build_paths.inc
+. `dirname $0`/../../build_paths.inc
 
-if [ ! -e $BUILD_DIR/tests/apicheck/apicheck ]; then
+if [ ! -e $BUILD_DIR/apicheck/apicheck ]; then
     echo API check tool not built!
     exit 1
+elif [ ! -e $BUILD_DIR/qml/Extinct/Animals/libExtinctAnimals.so ]; then
+    echo You need to build Extinct.Animals before you can dump QML API!
+    exit 1
 fi
 
 echo Self-testing API dump
-env QML2_IMPORT_PATH=$SRC_DIR/tests/apicheck/test \
-    $BUILD_DIR/tests/apicheck/apicheck --qml Extinct.Animals | \
-    diff -F '[.0-9]' -u $SRC_DIR/tests/apicheck/test/components.api -
+env QML2_IMPORT_PATH=$BUILD_DIR/qml \
+    $BUILD_DIR/apicheck/apicheck --qml Extinct.Animals | \
+    diff -F '[.0-9]' -u $SRC_DIR/tests/api/components.api -
 test $? != 0 && echo Error: Mismatch && exit 1
 echo All fine.

=== modified file 'tests/qmlapicheck.sh'
--- tests/qmlapicheck.sh	2015-11-06 08:46:15 +0000
+++ tests/qmlapicheck.sh	2015-11-30 15:39:52 +0000
@@ -27,7 +27,7 @@
 echo Dumping QML API of C++ components
 test -s $BUILD_DIR/components.api.new && rm $BUILD_DIR/components.api.new
 env ALARM_BACKEND=memory QML2_IMPORT_PATH=$BUILD_DIR/qml LD_LIBRARY_PATH=$BUILD_DIR/lib \
-    $BUILD_DIR/tests/apicheck/apicheck \
+    $BUILD_DIR/apicheck/apicheck \
     --qml $CPP 1>> $BUILD_DIR/components.api.new &&
     echo Verifying the diff between existing and generated API
 if [ $? -gt 0 ]; then

=== modified file 'tests/tests.pro'
--- tests/tests.pro	2015-08-06 17:15:48 +0000
+++ tests/tests.pro	2015-11-30 15:39:52 +0000
@@ -4,8 +4,10 @@
 autopilot_module.path = /usr/lib/python3/dist-packages/ubuntuuitoolkit
 autopilot_module.files = autopilot/ubuntuuitoolkit/*
 
-SUBDIRS += apicheck
+SUBDIRS += api
 
 INSTALLS += autopilot_module
 
 OTHER_FILES += qmlapicheck.sh
+
+check.commands += ./qmlapicheck.sh || exit 1;

=== modified file 'ubuntu-sdk.pro'
--- ubuntu-sdk.pro	2015-11-18 15:07:15 +0000
+++ ubuntu-sdk.pro	2015-11-30 15:39:52 +0000
@@ -8,7 +8,7 @@
 requires(qtHaveModule(quick))
 load(qt_parts)
 
-SUBDIRS += po documentation app-launch-profiler ubuntu-ui-toolkit-launcher
+SUBDIRS += po documentation app-launch-profiler ubuntu-ui-toolkit-launcher apicheck
 
 #when standalone we always want tests to be built
 !build_with_qt{

